import("math.lib");
import("filter.lib");
import("maxmsp.lib");
import("oscillator.lib");

//----------- note -------------
gate = checkbox("gate");
gate2 = gate : \(x).(x>x');
freq = hslider("freq ", 440, 20, 2000, 1);
gain = hslider("gain", 1, 0, 1, 0.01)  : smooth(0.999);

swbruit = checkbox ("swbruit") ;

freq1 = freq * vibrato * SampleHold ;

//-----------------------------------------------
// 			osc(freq) : Sinusoidal Oscillator
//-----------------------------------------------
xxx = environment {
	tablesize 	= 1 << 16;
	samplingfreq	= SR;

	time 		= (+(1)~_ ) - 1; 			// 0,1,2,3,...
	sinwaveform 	= float(time)*(2.0*PI)/float(tablesize) : sin;

	decimal(x)	= x - floor(x);
	phase(trig, freq) 	= freq/float(samplingfreq) : (+ : decimal : if(trig>0, 0, _)) ~ _ : *(float(tablesize));
	osc(trig, freq)	= rdtable(tablesize, sinwaveform, int(phase(trig,freq)) );
	osci(trig, freq)	= s1 + d * (s2 - s1)
			with {
				i = int(phase(trig, freq));
				d = decimal(phase(trig, freq));
				s1 = rdtable(tablesize+1,sinwaveform,i);
				s2 = rdtable(tablesize+1,sinwaveform,i+1);};
};


//**** definit un indicer qui va permettre de lire une table ****
// parametres : dur = duree en echantillons (minimun 1)
//				trig = quand > 0 declenche le cycle
// sortie : valeur variant de 0 a 1.0 en dur echantillons, reste a 1.0 ensuite
// NOTE : la fonction est protegee contre les durees nulles et les durees qui changent en cours de route

indicer(dur, trig) = I ~ (_,_) : /
	with {
			I(p, d) = if(trig>0.0, 0.0, min(d, p+1.0)),
					  max(1.0, if(trig>0.0, dur, d));
	};
	
ifunctTab(bpf, low, high, dur, trig) = s1 * (1.0 - d) + s2 *d : *(high - low) + low 
 	with {
 			phase = 100.0 * indicer(dur, trig) ;
			i = int(phase) ;
 			d = decimal(phase);
 			s1 = rdtable(101, bpf(time), i);
 			s2 = rdtable(101, bpf(time), i+1);
		};

bpf9  = bpf.start(0,1.0) : bpf.point(25,0.25) : bpf.point(50,0.1) : bpf.point(75,0.05) : bpf.end(100,0);
bpf10 = bpf.start(0,0.5) : bpf.point(20,1.0)  : bpf.point(50,0.1) : bpf.point(75,0.02) : bpf.end(100,0);
bpf11 = bpf.start(0,0.0) : bpf.point(10,0.02) : bpf.point(15,0.1) : bpf.point(25,0.5)  : bpf.point(30,0.95) : bpf.point(33,1) : bpf.point(85,0.95) : bpf.point(90,0.9) : bpf.point(95,0.05) : bpf.end(100,0);
bpf12 = bpf.start(0,0.0) : bpf.point(10,0.2)  : bpf.point(15,0.10): bpf.point(25,0.5)  : bpf.point(30,0.95) : bpf.point(33,1.0) : bpf.end(100,0);
bpf13 = bpf.start(0,0.0) : bpf.point(13,0.5)  : bpf.point(30,1.0) : bpf.point(60,0.2)  : bpf.point(75,0.04) : bpf.end(100,0);
bpf14 = bpf.start(0,1.0) : bpf.point(12,0.75) : bpf.point(25,1.0) : bpf.point(50,0.25) : bpf.point(75,0.05) : bpf.end(100,0);
bpf15 = bpf.start(0,1.0) : bpf.point(5,0.1)   : bpf.point(10,0.02) : bpf.point(25,0.0) : bpf.end(100,0);
bpf16 = bpf.start(0,0.0) : bpf.point(15,0.1) : bpf.point(30,0.50) : bpf.point(40,0.95) : bpf.point(50,1.0) : bpf.point(60,0.96) : bpf.point(70,0.5) : bpf.point(85,0.1) : bpf.end(100,0);
bpf17 = bpf.start(0,1.0) : bpf.point(11,0.5) : bpf.point(25,0.25) : bpf.point(50,0.1) : bpf.point(75,0.05) : bpf.end(100,0);


env(trig, dur, bpfxf, low, high) =  
	if (bpfx == 9,  ifunctTab(bpf9,  low, high, dur, trig),
	if (bpfx == 10, ifunctTab(bpf10, low, high, dur, trig),
	if (bpfx == 11, ifunctTab(bpf11, low, high, dur, trig),
	if (bpfx == 12, ifunctTab(bpf12, low, high, dur, trig),
	if (bpfx == 13, ifunctTab(bpf13, low, high, dur, trig),
	if (bpfx == 14, ifunctTab(bpf14, low, high, dur, trig),
	if (bpfx == 15, ifunctTab(bpf15, low, high, dur, trig),
	if (bpfx == 16, ifunctTab(bpf16, low, high, dur, trig),
					ifunctTab(bpf17, low, high, dur, trig)
	)))))))) with { bpfx = int(bpfxf); };

swenv = checkbox("swenv");
indexFM = hslider("h:FM/index [multi:1]", 6, 0, 20, 0.1) : smooth(0.999);	
dur = 3000 * attack / 100. ;
nbpf = 9;
envelop(swenv) = select3(swenv, env1, env2);

env1 = env(gate2, nsamples, nbpf, 0, 1)
	with { 
		nsamples = max(10, dur * SR / 1000.0) ; 
	}	 ;
	
//------------ enveloppe tenue --------
	
attack = hslider("v:General Parameters/att4", 100, 1, 2000, 1) ;
release = attack * 2 ;
	
durr = select2(gate, release, attack);
env2= line(gate, durr) ;
	
				
//----------- oscillos -------
	
fmfm2 (freq, amp, transpfm, index, transp) = 
	env2 * amp *
	osci(freq * transp + 
		env2 * amp * index *
			freq * transpfm * transp * osci(freq * transpfm * transp)) ;



fmfm1 (trig, freq, amp, transpfm, index, transp) = 
	env1 * amp *
	xxx.osci(trig, freq * transp + 
		env1 * amp * index *
			freq * transpfm * transp * xxx.osci(trig, freq * transpfm * transp)) ;

synthfm(swenv) = select2(swenv, fmfm1 (gate2, freq1, gain, fmfreq, indexFM, 1.0) , 
	fmfm2 (freq1, gain,  fmfreq, indexFM, 1.0));

noiseenv(swenv) = select2(swenv, noise * env1 * gain , noise * env2 * gain);

//--------- synth -----------
freqmod = hslider("h:FM/freqmod", 1, 1, 4, 1);
fmfreq = sqrt(freqmod):+(0.001);

synth = select2(swbruit, synthfm(swenv), noiseenv(swenv));
// synth = synthfm(swenv);
	
//-------------- vibrato ---------------//
ampvib = hslider("ampvib", 0.01, 0, 0.1, 0.001);
freqvib = 5.6;

vibrato =  1 + (ampvib * osci(freqvib));
	
//------------- sample&hold -----------//	
cocoX  = hslider("h:SHold/cocoX [style:knob]", 400, 1 , 1000, 0.1);
cocoY = hslider("h:SHold/cocoY [style:knob]", 10, 1, 50, 0.1);
ampSH = hslider("h:SHold/ampSH [style:knob]", 0.1, 0, 0.9, 0.01) ;

trigSH  = pulse(SR/cocoY) ;
SampAndHold (x, trig) = (* (1 - trig) + x * trig) ~ _ ;	
SampleHold = 1 + (ampSH * SampAndHold(triangle(cocoX), trigSH));

//------------- filtres -----------//	
f1 = hslider("v:filtre/f1 [multi:0]" , 500, 20, 4000, 0.01) : smooth(0.999);
f2 = 2 * f1 ;
gain01 = 0,8;
gain02 = 0.8;
Q = 1;

filtre1(x) = BPF(x, f1, gain01, Q) ;
filtre2(x) = BPF(x, f2, gain02, Q) ;

filtres(x) = filtre1(x), filtre2(x) ;

//------------- delay -----------//	
mixdel = hslider("mix echo", 0.2, 0, 1, 0.01) ;
mixwet = 1.0 - mixdel;
deldur1 = 0.250 * SR ;
deldur2 = 0.180 * SR ;
echos = _<:((_,_:> delay1s (deldur1)) ~ *(0.3)), ((_,_:> delay1s (deldur2)) ~ *(0.4));

tbar		= 0.1;					// attack/release time in seconds
gbar		= exp(-1/(SR*tbar));	// corresponding gain factor
envbar		= abs : *(1-gbar) : + ~ *(gbar) : linear2db;
	
left_meter(x)	= attach(x, envbar(x) : hbargraph("left", -96, 10));	
right_meter(x)	= attach(x, envbar(x) : hbargraph("right", -96, 10));	
//------------- process -----------//	
process = vgroup("Synth1 [style:multikeyboard]", synth : filtres <: *(mixdel), *(mixwet) :  echos, (_<:_,_) :> (_,_):vgroup("Vu metres",(left_meter,right_meter))); 